#include "tbb/parallel_for.h"
#include "tbb/blocked_range2d.h"

using namespace tbb;

const int SIZE = 500;

int data[SIZE][SIZE];

class Mandle
{
  int inset( double ix, double iy ) const
  {
    int iterations = 0;
    double x = ix, y = iy, x2 = x*x, y2 = y*y;
    double x3 = 0,y3 = 0;
    while (( x3 + y3 < 4 ) && ( x2 + y2 < 4 ) && ( iterations < 1000 ) )
    {
      y  = 2 * x * y + iy;
      x  = x2 - y2 + ix;
      x2 = x * x; x3 = x2;
      y2 = y * y; y3 = y2;
      iterations++;
    }
    return iterations;
  }

public:
  void operator()( const blocked_range2d<int,int>&range ) const
  {
     for( int y = range.rows().begin(); y != range.rows().end(); y++ )
     {
       for( int x = range.cols().begin(); x != range.cols().end(); x++ )
       {
         double xv = 0.75*( (double)(x - SIZE/2) ) / (double)(SIZE/4);
         double yv = 0.75*( (double)(y - SIZE/2) ) / (double)(SIZE/4);
         data[x][y] = inset(xv,yv);
       }
     }
  }
  Mandle(){}
};

int main()
{
  parallel_for( blocked_range2d<int,int>(0,500,10,0,500,10), Mandle() );
  return 0;
}
