#include <pthread.h>
#include <stdio.h>
#include <sys/time.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/processor.h>
#include <sys/procset.h>

void * threadcode( void*id )
{
  int *stack = calloc( sizeof(int), 2048 );
  processor_bind( P_LWPID, P_MYID, ((int)id*4) & 63, 0 );
  for( int i=0; i<1000; i++ )
  {  
    hrtime_t start = gethrtime();
    double total = 0.0;
    for( int h=0; h<100; h++ )
     for( int k=0; k<256*1024; k++ )
      total += stack[ ( (h*k) ^ 20393 ) & 2047 ] 
              *stack[ ( (h*k) ^ 12834 ) & 2047 ];
    hrtime_t end = gethrtime();
    if ( total == 0 ){ printf( "" ); }
    printf( "Time %f s %i\n", 
            ( (double)end - (double)start ) / 1000000000.0,
            (int)id );
  } 
}


int main( int argc, char*argv[] )
{
  pthread_t threads[20];
  int nthreads = 8;
  if ( argc > 1 ) { nthreads = atoi( argv[1] ); }
  for( int i=0; i<nthreads; i++ ) 
  { 
     pthread_create( &threads[i], 0, threadcode, (void*)i ); 
  }
  for( int i=0; i<nthreads; i++) { pthread_join( threads[i], 0 ); }
  return 0;
}
