#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <pthread.h>

#include <sys/types.h>
#include <sys/processor.h>
#include <sys/procset.h>

int nthreads = 8;

void *experiment( void *id )
{
  unsigned int seed = 0;
  processor_bind( P_LWPID, P_MYID, ((int)id*2), 0 );
  int count = 100000000;
  for( int i=0; i<count; i++ )
  {
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
       seed += (seed<<2) ^ (seed|33556);
  }
  if ( seed == 1 ) { printf( "" ); }
}

int main( int argc, char* argv[] )
{
  pthread_t threads[64];
  if ( argc > 1 ) { nthreads = atoi( argv[1] ); }
  for( int i=0; i<nthreads; i++ )
  {
    pthread_create( &threads[i], 0, experiment, (void*)i );
  }
  for( int i=0; i<nthreads; i++ )
  {
    pthread_join( threads[i], 0 );
  }
  return 0;
}
