#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/time.h>

double now()
{
  struct timeval time;
  gettimeofday( &time, 0 );
  return (double)time.tv_sec + (double)time.tv_usec / 1000000.0;
}

#define COUNT 100000000
volatile int stop = 0;

void *spin( void *id )
{
  while( !stop ) {}
}

int main( int argc, char* argv[] )
{
  pthread_t threads[256];
  int nthreads = 1;
  if ( argc > 1 ) { nthreads = atoi( argv[1] ); }
  nthreads--;
  for( int i=0; i<nthreads; i++ )
  {
    pthread_create( &threads[i], 0, spin, (void*)0 );
  }

  double start=now();
  int total = 0;
  for( int h=0; h<COUNT; h++ )
    total += ( total << 2 ) ^ ( total | 33556 );
  if ( total == 0 ) { printf( "total==0\n" ); }
  double end=now();
  printf( "Time %f s\n", ( end - start ) );
  stop = 1;
  for( int i=0; i<nthreads; i++ )
  {
    pthread_join( threads[i], 0 );
  }
  return 0;
}
